﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.5
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Dim is_access As Accessibility
	Public gs_status As String
	Public gs_mobilenumber As String
	Public gs_vouchernumber As String
	Public gs_voucherseries As String
	
	Public billing_screen As billing
	
	Private ilbl_add As Label
	Private ilbl_backbutton As Label
	Private ilbl_clickbranchname As Label
	Private ilbl_refresh As Label
	Private ip_dashboardpanel As Panel
	Private ip_titlelabel As Label
	Private ip_toppanel As Panel
	Private it_billinglist As B4XTable
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	
	Root.LoadLayout("list_billing")
	
	billing_screen.Initialize
	B4XPages.AddPage("billing", billing_screen)
	
End Sub

Sub B4XPage_Appear
	gs_status = "A"
	BillingList
End Sub

Sub BillingList
	it_billinglist.Clear

	it_billinglist.HeaderFont = xui.CreateFont(Typeface.DEFAULT_BOLD, 15/is_access.GetUserFontScale)
	it_billinglist.LabelsFont = xui.CreateFont(Typeface.DEFAULT, 14/is_access.GetUserFontScale)

	Dim sl_col As B4XTableColumn =  it_billinglist.AddColumn("S.No", it_billinglist.COLUMN_TYPE_TEXT)
	sl_col.Width = 70dip
	
	it_billinglist.AddColumn("Sales Date", it_billinglist.COLUMN_TYPE_TEXT)
	
	it_billinglist.AddColumn("Mobile Number", it_billinglist.COLUMN_TYPE_TEXT)
	
	Dim permorderstatus_col As B4XTableColumn = it_billinglist.AddColumn("Sales No.", it_billinglist.COLUMN_TYPE_TEXT)
	permorderstatus_col.Width = 90dip
	
	Dim totalpiece_col As B4XTableColumn = it_billinglist.AddColumn("Total Piece", it_billinglist.COLUMN_TYPE_TEXT)
	totalpiece_col.Width = 120dip
	
	Dim totalmeter_col As B4XTableColumn = it_billinglist.AddColumn("Total Meter", it_billinglist.COLUMN_TYPE_TEXT)
	totalmeter_col.Width = 120dip
	
	Dim totalqty_col As B4XTableColumn = it_billinglist.AddColumn("Total Quantity", it_billinglist.COLUMN_TYPE_TEXT)
	totalqty_col.Width = 120dip
	
	it_billinglist.AddColumn("Voucher Series", it_billinglist.COLUMN_TYPE_TEXT)
	
	it_billinglist.AddColumn("Voucher Number", it_billinglist.COLUMN_TYPE_TEXT)

	ShowTable_SalesBillingList
	SetColumnAlignmentRight("Total Piece")
	SetColumnAlignmentRight("Total Meter")
	SetColumnAlignmentRight("Total Quantity")
	HideColumn("Voucher Series")
	HideColumn("Voucher Number")
End Sub

Public Sub HideColumn(ColID As String)
	Dim poCol As B4XTableColumn = it_billinglist.GetColumn(ColID)
	If poCol <> Null And poCol.IsInitialized Then
		Dim piVisibleColIndex As Int = it_billinglist.VisibleColumns.IndexOf(poCol)
		If piVisibleColIndex >= 0 Then
			it_billinglist.VisibleColumns.RemoveAt(piVisibleColIndex) 'hide column
			If it_billinglist.clvData.IsInitialized Then
				If it_billinglist.clvData.Size > piVisibleColIndex Then
					it_billinglist.clvData.RemoveAt(piVisibleColIndex)
				End If
			End If
			poCol.Panel.RemoveViewFromParent
		End If
		it_billinglist.Refresh
	End If
End Sub

Sub SetColumnAlignmentRight(columnID As String)
	Dim column As B4XTableColumn = it_billinglist.GetColumn(columnID)
	it_billinglist.MaximumRowsPerPage = 20
	it_billinglist.BuildLayoutsCache(it_billinglist.MaximumRowsPerPage)
	For i = 1 To column.CellsLayouts.Size - 1
		Dim pnl As B4XView = column.CellsLayouts.Get(i)
		pnl.GetView(0).SetTextAlignment("CENTER", "RIGHT")
	Next
End Sub

Sub ShowTable_SalesBillingList
	
	Dim ls_serialnumber As Int = 0
		
	Dim list_assign As List
	list_assign.Initialize
		
	Dim s As String = File.ReadString(File.DirAssets, "textile.json")
		
	Dim parser As JSONParser
	parser.Initialize(s)
		
	Dim Data As List = parser.NextArray
	
	Dim coldata As Map
	coldata.Initialize
	
	coldata = Data.Get(0)
		
'	For Each coldata As Map In Data
				
		ls_serialnumber = ls_serialnumber + 1
				
		Dim ls_mobilenumber As String = coldata.Get("mobilenumber")
		Dim ls_prefix As String = coldata.Get("prefix")
		Dim ls_vouchernumber As String = coldata.Get("vouchernumber")
		Dim ls_voucherseries As String = coldata.Get("voucherseries")
		Dim ls_voucherversion As String = coldata.Get("voucherversion")
		Dim ls_suffix As String = coldata.Get("suffix")
		Dim ls_voucherdate As String = coldata.Get("voucherdate")
		Dim ls_totalpiece As String = coldata.Get("totalpiece")
		Dim ls_totalmeter As String = coldata.Get("totalmeter")
		Dim ls_totalquantity As String = coldata.Get("totalquantity")
		Dim ls_vouchernumbercheck As String = coldata.Get("vouchernumber")
				
		Dim l As Long
		DateTime.DateFormat = "yyyy-mm-dd"
		Dim datestring As String = ls_voucherdate
		l = DateTime.DateParse(datestring)
		DateTime.DateFormat = "dd-mm-yyyy"
		ls_voucherdate = DateTime.Date(l)
				
		If ls_suffix = "null" Or ls_suffix = Null Or ls_suffix = "" Then
			ls_suffix = ""
		End If
				
		If ls_prefix = "null" Or ls_prefix = Null Or ls_prefix = "" Then
			ls_prefix = ""
		End If
				
		ls_vouchernumber = ls_prefix & ls_vouchernumber & ls_suffix
				
		Dim lo_row(9) As Object
				
		lo_row(0) = ls_serialnumber
		lo_row(1) = ls_voucherdate
		lo_row(2) = ls_mobilenumber
		lo_row(3) = ls_vouchernumber
		lo_row(4) = ls_totalpiece
		lo_row(5) = ls_totalmeter
		lo_row(6) = ls_totalquantity
		lo_row(7) = ls_voucherseries
		lo_row(8) = ls_vouchernumbercheck

		list_assign.Add(lo_row)

'	Next

	it_billinglist.SetData(list_assign)
	
End Sub

Private Sub it_billinglist_CellClicked (ColumnId As String, RowId As Long)
	
	gs_status = "U"
	
	Dim RowData As Map = it_billinglist.GetRow(RowId)
	
	gs_mobilenumber = RowData.Get("Mobile Number")
	gs_voucherseries = RowData.Get("Voucher Series")
	gs_vouchernumber = RowData.Get("Voucher Number")

	Log("Mobile Number : " & gs_mobilenumber)
	Log("Voucher Series : " & gs_voucherseries)
	Log("Voucher Number : " & gs_vouchernumber)

	B4XPages.ShowPage("billing")
	
End Sub

Private Sub ilbl_add_Click
	gs_status = "N"
	B4XPages.ShowPage("billing")
End Sub
